//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBGuestControl extends MSBExtendedListButton
config(BobControl);

var MSBPawn Guest;
var MSBActor EyeActor;
var MSBUdpLink PoseLink, HeadLink, EyeLink;

var vector BaseEyeLocation;

var() config float BlendTime;
var() config int BtnBrowUp;
var() config int BtnBrowDown;

var() config array<int> BtnPose;
var int LastPoseBtn;
var() config array<string> PoseName;

event PostBeginPlay()
{
super.PostBeginPlay();
saveconfig();
PoseLink=Spawn(class'MSBUdpLink',self);
HeadLink=Spawn(class'MSBUdpLink',self);
EyeLink=Spawn(class'MSBUdpLink',self);

PoseLink.InitUdpLink(3184);
HeadLink.initUdpLink(3185);
EyeLink.InitUdpLink(3186);

}

event PreSaveGame()
{
PoseLink=None;
HeadLink=None;
EyeLink=None;
}


event PostLoadSavedGame()
{
PoseLink=Spawn(class'MSBUdpLink',self);
HeadLink=Spawn(class'MSBUdpLink',self);
EyeLink=Spawn(class'MSBUdpLink',self);

PoseLink.InitUdpLink(3184);
HeadLink.initUdpLink(3185);
EyeLink.InitUdpLink(3186);
}

function setGuestPose(int i)
{
local MSBSetPoseNode spn;

if (PoseName[i]!="")
  {
  LastPoseBtn=BtnPose[i];
//  Guest.iniPosing();
  spn=spawn(class'MSBSetPoseNode');
  spn.PoseName=PoseName[i];
  spn.BlendTime=BlendTime;
  spn.PoseActor=Guest;
  spn.execute("");
  spn.Destroy();
  }
}

function Trigger(Actor Other,Pawn EventInstigator)
{
//local rotator HeadTurn;
//local vector eyeVect;
//local int datacheck;
local int i;

//if (Other.IsA('MSBPropertyButton') && EyeActor!=None && Guest!=None)
//  {
//  BaseEyeLocation=EyeActor.Location-Guest.Location;
//  EyeActor.SetLocation(0*Location);
//  Guest.AttachToBone(EyeActor,'Bip01 head');
//  }

//if (Other==EyeLink && EyeActor!=None)
//  {
//  datacheck=int(EyeLink.Data);
//  if (datacheck/10>0)
//    eyeVect.X=1;
//  if (datacheck/10<0)
//    eyeVect.X=-1;
//
//  if (datacheck<-1)
//    datacheck+=20;
//  if (datacheck>1)
//    datacheck-=20;
//
//  if (datacheck%10>0)
//    eyeVect.Y=1;
//  if (datacheck%10<0)
//    eyeVect.Y=-1;
//  EyeActor.SetRelativeLocation(BaseEyeLocation+eyeVect);
//  }


//  HeadTurn.Pitch=-8192*Mouse.joyUAxis/6;
//  HeadTurn.Roll=-4096*Mouse.joyVaxis/6;
//  if (VSize(vector(HeadTurn))>0)
//    Guest.SetBoneRotation('Bip01 Neck',HeadTurn);


if (Other==PoseLink && Guest!=None && int(PoseLink.Data)!=LastPoseBtn)
  {

  if (Other==PoseLink && PoseLink.Data!="")
    for(i=0;i<BtnPose.length;i++)
      if(int(PoseLink.Data)==BtnPose[i])
        setGuestPose(i);
  }
//  MSBHud(M.myHUD).debugString=Mouse.joyXaxis@Mouse.joyYaxis@Mouse.joyUaxis@Mouse.joyVaxis;
}

DefaultProperties
{
ButtonList(0)="MSBPropertyButtons.MSBPropertyButton3D"
Properties(0)="Guest"
ButtonList(1)="MSBPropertyButtons.MSBPropertyButton3D"
Properties(1)="EyeActor"
ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(2)="BlendTime"
BtnPose(0)=49
PoseName(0)="handsdown"
BtnPose(1)=50
PoseName(1)="TestPose1"
BtnPose(2)=51
PoseName(2)="TestPose2"
BtnPose(3)=52
PoseName(3)="TestPose3"
BtnPose(4)=53
PoseName(4)="TestPose4"
BtnPose(5)=54
PoseName(5)="TestPose5"
BtnPose(6)=55
PoseName(6)="TestPose6"
BtnPose(7)=56
PoseName(7)="TestPose7"
BtnPose(8)=57
PoseName(8)="TestPose8"
BtnPose(9)=58
PoseName(9)="TestPose9"

BlendTime=0.2
col=(R=0,G=64,B=200)
width=64

}
