//-----------------------------------------------------------
//  A ListButton Spawns a number of SubButtons
//  just like in a Menu.
//  Once another Button is triggered, the Menu is being removed.
//
//  Copyright 2005 Friedrich Kirschner
//-----------------------------------------------------------
class MSBListButton extends MSBGuiOverlay
config(MSBCode);

var config array<String> ButtonList;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;
var bool bListOpen;
var bool bCircle;

//Buttonlist page system:
var int lastpage,maxButtons, currentpage;

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

if (yPos>C.CLipY-height)
  yPos=C.ClipY-height-256;
if (xPos>C.ClipX-width)
  xPos=C.ClipX-width-64;

if ((currentpage+1)*8<=Buttonlist.length)
  maxButtons=(currentpage+1)*8;
else
  maxButtons=Buttonlist.length;

// revisit button distribution...
for (i=currentpage*8;i<maxButtons; i++)
  {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[i]=Spawn(ButtonClass,self,,M.Location);

    if (ListButton[i].height<60)
      ListButton[i].xPos=xpos+width;
    else
      {
      ListButton[i].xPos=xpos-16 -2*width;
      if (Listbutton[i].xPos<C.ClipX)
        ListButton[i].xPos=xpos+16+2*width;
      }
    if (i>currentpage*8)
      {                          //horizontal alignment
      ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
      if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
        {
        ListButton[i].ypos=yPos-(i*ListButton[i].height+height+1);
        }
      }
    else
      ListButton[i].yPos=ypos;
    ListButton[i].SubLevel=SubLevel+1;
  }

if (Buttonlist.length>8)
  {
  //create next/prev page buttons
  ListButton[i]=Spawn(class'MSBNextPageButton',self,,M.Location);
  MSBNextPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;

  ListButton[++i]=Spawn(class'MSBPrevPageButton',self,,M.Location);
  MSBPrevPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;
  }
}


DefaultProperties
{
tooltip="Click for more Options"
xPos=0
yPos=64
}
