//-----------------------------------------------------------
//  Copyright 2006 Friedrich Kirschner
//-----------------------------------------------------------

class MSBNodeButton extends MSBListButton;

#exec texture Import File=Textures\Node.tga Name=Node_Icon Masked=1 Alpha=1 Mips=On

var MSBNodeInButton NodeIn;
var MSBNodeOutButton NodeOut;

var MSBScriptNode Order;

var bool bDragged;
var bool bHiddenBranch;
var bool rHasClickedAgain;
var bool bhideBranch;

var string special;

var float xDist,yDist;

var array<string> Properties;

var Material MatHighlight;
var array<Actor> FocusActor;

event PostBeginPlay()
{
M=MSBController(Level.getLocalPlayerController());
M.LevelNodes[M.LevelNodes.Length]=self;

NodeIn=Spawn(class'MSBNodeInButton');
NodeIn.myNode=self;
NodeOut=Spawn(class'MSBNodeOutButton',self,,M.Location);
NodeOut.myNode=self;
NodeOut.col=col;
super.PostBeginPlay();
}

function MouseOver(Canvas C)
{
local int i,j;
local string ObjectName, MapName;

super.MouseOver(C);
if (bEnabled)
  {
  for (i=0;i<ButtonList.length;i++)
   {
    if (Caps(ButtonList[i])=="MSBPROPERTYBUTTONS.MSBPROPERTYBUTTON3D")
      {
      ObjectName=Order.GetPropertyText(Properties[i]);
      ObjectName=GetItemName(ObjectName);
      ObjectName-="'";
      MapName=Left(string(Level), InStr(string(Level), "."));
      ObjectName=MapName$"."$ObjectName;
      FocusActor[j]=Actor(FindObject(ObjectName,class'Actor'));
      if (FocusActor[j]!=None)
        FocusActor[j].SetOverlayMaterial(MatHighlight, 0.1,false);
      }
    if (Order.IsA('MSBRootNode'))
      MSBRootNode(Order).BasePawn.SetOverlayMaterial(MatHighlight, 0.1,false);
    }
  }
}

function initButton(Canvas C)
{
if (bDragged)
  {
  xPos=Mouse.xPos+xDist;
  yPos=Mouse.yPos+yDist;
  }

super.initButton(C);

C.SetPos(xPos,yPos);
C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;
C.SetDrawColor(textCol.R,textCol.G,textCol.B);
C.DrawText(BtnName);
C.SetDrawColor(col.R,col.G,col.B);
C.FontScaleX=fontScale/1024 * C.ClipX;
C.FontScaleY=fontScale/1024 * C.ClipX;

if (bEnabled)
 {
 if (rHasClicked && Mouse.btnTwo)
   {
   rHasClickedAgain=true;
   RightBtnFinished(C);
   rHasClickedAgain=false;
   }
 }
}

function LeftBtn(Canvas C)
{
local int i;

super.LeftBtn(C);
for (i=0;i<Buttonlist.Length; i++)
  {
   MSBPropertyButton(ListButton[i]).Parent=self;
   MSBPropertyButton(ListButton[i]).Property=Properties[i];
  }
}

function RightBtn(Canvas C)
{
super.RightBtn(C);
bDragged=true;
xDist=xPos-Mouse.xPos;
yDist=yPos-Mouse.yPos;

}

function RightBtnFinished(Canvas C)
{
local int i;

rHasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnTwo=false;
bDragged=false;
}

function hideNode()
{
bHiddenBranch=true;
M.myHUD.RemoveHudOverlay(NodeOut);
M.myHUD.RemoveHudOverlay(NodeIn);
M.myHUD.RemoveHudOverlay(self);
}

function showNode()
{
local HudOverlay mOverlay;

mOverlay=M.myHUD.Overlays[M.myHUD.Overlays.Length-1]; // POP Mouse from Overlay Stack
M.myHUD.RemoveHudOverlay(mOverlay);
M.myHUD.AddHudOverlay(self);
if (NodeIn!=None)
  M.myHUD.AddHudOverlay(NodeIn);
M.myHUD.AddHudOverlay(NodeOut);
M.myHUD.AddHudOverlay(mOverlay);            //PUSH Mouse back on top
bHiddenBranch=false;
}

defaultproperties
{
widthRel=70
heightRel=18
Mat=Node_Icon
MatHighLight=Material'MovieSandboxTextures.TransRed'
BtnName="Node"
ypos=100
xpos=100
ButtonList(0)=None;
col=(R=225,G=225,B=255,A=255)
}

