#exec OBJ LOAD FILE=MovieSandboxMeshes.usx

class MSBCamera extends MSBActor;

//internal
var PlayerController PC;

//shakycamera
var bool bShaky;
var int maxXShake;
var int maxYShake;
var int maxZShake;

//Camera Properties
var Actor ViewTarget;
var bool lazyCam;
var int FOV;

var rotator BaseRotation;
var rotator maxRot;


var bool bDepth;

function PostBeginPlay()
{
super.PostBeginPlay();
Enable('Tick');
PC=Level.GetLocalPlayerController();
}

function Tick(float DeltaTime)
{
 if (PC.ViewTarget==self)
   {
   //set FOV
   if (PC!=None)
    {
    PC.DefaultFOV=FOV;
    PC.DesiredFOV=FOV;
    }
   //set ViewTarget
   if (ViewTarget!=None)
     SetRotation(rotator(ViewTarget.Location - self.Location));
   //set CameraShake
   if (bShaky)
     ShakeCamera();
   }
}

function ShakeCamera();

function Reset()
{
super.Reset();
BaseRotation=Rotation;
ViewTarget=None;
bShaky=false;
lazyCam=false;
}

defaultproperties
{
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(5)="FOV"
ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonAttachToBone"
Properties(6)="Dummy"
ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonViewport"
Properties(7)="Dummy"

FOV=90

lazyCam=false
bHidden=false
bStatic=False

bDisplayed=false

maxXShake=10;
maxYShake=-10;
maxZShake=12;

Physics=PHYS_None
bDirectional=True
CollisionRadius=24.0
CollisionHeight=16.0
bUseCylinderCollision=true
bCollideActors=True
bBlockActors=False
bCollideWorld=False
bProjTarget=True

DrawType=DT_StaticMesh
StaticMesh=StaticMesh'MovieSandBoxMeshes.helperMeshes.CameraBody'
Skins(0)=Material'MovieSandboxTextures.lightBlue'
DrawScale=0.5
AmbientGlow=100
}
