//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdHud extends MSBHud;

var MSBVoxelEdController CC;
var vector chgLocAbs;
var float dTime;

function PostBeginPlay()
{
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);
dTime=DeltaTime;
}

function PostRender(Canvas C)
{
local vector chgLocX,chgLocY,chgLocZ,xAxis,yAxis,zAxis;
local int i;

super.PostRender(C);

//Draw the MainMenu
if (DrawOverlays)
  {
  for (i = 0; i < Overlays.length; i++)
    Overlays[i].Render(C);
  }

//Move the MSBBlockBrush around
else
  {
  if (CC.DrawBrush!=None)
    {
    GetAxes(CC.drawBrush.Rotation,xAxis,yAxis,zAxis);
    if (MouseOverlay.bShiftDown)
      chgLocZ=-zAxis*(MouseOverlay.yPos-CC.oldY);
    else
      {
      chgLocY=yAxis*(MouseOverlay.xPos-CC.oldX);
      chgLocX=-xAxis*(MouseOverlay.yPos-CC.oldY);
      }

    if (CC.bGrid)
      {
      chgLocX*=dTime*CC.Gridspacing/2*10;
      chgLocY*=dTime*CC.Gridspacing/2*10;
      chgLocZ*=dTime*CC.Gridspacing/2*10;
      if (VSize(chgLocAbs)>CC.GridSpacing || VSize(chgLocAbs)<-CC.GridSpacing)
        {
        if (chgLocY dot yAxis >0)
          chgLocAbs=CC.Gridspacing*yAxis;
        if (chgLocY dot yAxis <0)
          chgLocAbs=-CC.Gridspacing*yAxis;

        if (chgLocX dot xAxis >0)
          chgLocAbs=CC.Gridspacing*xAxis;
        if (chgLocX dot xAxis <0)
          chgLocAbs=-CC.Gridspacing*xAxis;

        if (chgLocZ dot zAxis >0)
          chgLocAbs=CC.Gridspacing*zAxis;
        if (chgLocZ dot zAxis <0)
          chgLocAbs=-CC.Gridspacing*zAxis;

        CC.DrawBrush.SetLocation(CC.DrawBrush.Location+chgLocAbs);
        chgLocAbs=chgLocAbs*0;
        }
      else
        chgLocAbs=chgLocAbs+chgLocX+chgLocY+chgLocZ;
      }
    else  //ToDO: work in Axes
      {
      chgLocX=chgLocX*dTime*80;
      CC.DrawBrush.SetLocation(CC.DrawBrush.Location+chgLocAbs);
      }

    MouseOverlay.xPos=CC.oldX;
    MouseOverlay.yPos=CC.oldY;
    }
  if (MouseOverlay.pressedKey==1 && CC.DrawBrush!=None)
    {
    CC.DrawBrush.Trigger(self,none);
    MouseOverlay.pressedKey=0;
    }
  if (MouseOverlay.pressedKey==2 && CC.DrawBrush!=None)
    {
    CC.DrawBrush.Trigger(none,none);
    MouseOverlay.pressedKey=0;
    }

  }
MouseOverlay.hudTargetActor=None;
}

DefaultProperties
{
MenuButtons(0)="MSBCode.MSBNaviButton";
MenuButtons(1)="MSBVoxelCharacterEditor.MSBColorSelectButton";
MenuButtons(2)="MSBVoxelCharacterEditor.MSBVoxelCharEditButton";
MenuButtons(3)="MSBVoxelCharacterEditor.MSBVoxelEdPoser";
MenuButtons(4)="MSBVoxelCharacterEditor.MSBSpawnMouthButton";
MenuButtons(5)="MSBVoxelCharacterEditor.MSBSwitchModeButton";
MenuButtons(6)="MSBVoxelCharacterEditor.MSBGrowBrushButton";
MenuButtons(7)="MSBVoxelCharacterEditor.MSBShrinkBrushButton";
MenuButtons(8)="MSBCode.MSBBackToMainButton";
//MenuButtons(8)="MSBVoxelCharacterEditor.MSBCreateBobHead";
drawOverlays=true
}
